SystemOrganization addCategory: #'Magma seaside'!

!MagmaLocalLocation methodsFor: '*magma seaside' stamp: 'kph 9/22/2006 03:09'!
newSession
	"For local, we have to determine whether the files are already in-use by another
	local-connection.  If they are, create a new session sharing the original's
	repositoryController, Otherwise open the files."

 ^self sessionClass openLocal: path
	 ! !

!MagmaLocalLocation methodsFor: '*magma seaside' stamp: 'kph 6/28/2006 04:21'!
repositoryPath

^FileDirectory default fullNameFor: path! !

!MaObjectRepository methodsFor: '*magma seaside' stamp: 'kph 9/20/2006 23:38'!
graphBufferAt: oidInteger using: aMaReadStrategy
	"Answers a MaSerializedGraphBuffer."

	| answer rootBuffer |
	answer _ MaSerializedGraphBuffer new: 400.
	rootBuffer _ 
		filer
			appendObject: oidInteger
			into: answer.

	rootBuffer
		appendGraphUsing: (aMaReadStrategy signalBeginningToRead: oidInteger)
		into: answer
		currentDepth: 1
		minDepth: aMaReadStrategy minimumDepth
		with: Set new
		filer: filer.
	^ answer! !

!MaObjectBuffer methodsFor: '*magma seaside' stamp: 'kph 9/20/2006 13:39'!
appendGraphUsing: aMaReadStrategy into: aMaSerializedGraphBuffer currentDepth: currentDepth minDepth: minDepth with: alreadyAppendedSet filer: aMaObjectFiler

	1
		to: self objectInstSize
		do:
			[ :varIndex | | oid |
			(MaOidCalculator isOidForOptimizedObject: (oid _ self maInstVarAt: varIndex))
				ifFalse:
					[ | newMinDepth | 

				(newMinDepth := aMaReadStrategy 
						testRead: oid
						wantedAt: currentDepth
						to: minDepth
						forAttribute: varIndex
						ofClassWithId: self classId
						version: self classVersion) ~= false ifTrue: [
						
							self
								appendGraphNode: oid
								into: aMaSerializedGraphBuffer
								using: aMaReadStrategy
								currentDepth: currentDepth
								minDepth: newMinDepth
								with: alreadyAppendedSet
								filer: aMaObjectFiler 
							].
					  ]
		]
! !

WAConfigurationAttribute subclass: #WAMagmaLocationAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaLocationAttribute methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 10:00'!
accept: aVisitor with: anObject

	^ aVisitor visitMagmaLocationAttribute: self with: anObject! !

!WAMagmaLocationAttribute methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 12:13'!
options

	^ MagmaLocation subclasses! !

WAComponent subclass: #WAMagmaControlPanel
	instanceVariableNames: 'application psuedoAppSession repositoryControlPanel textInput doneIt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaControlPanel commentStamp: 'kph 9/4/2006 01:55' prior: 0!
Architecture:

This control panel is available in the magma configuration pane of the seaside/config application. Since the seaside/config application session is not, nor should it be a MagmaSession, this control panel has to manage its own magmaSession.

This control panel anticipates that each application using magma to have its own repository control/status panel. The repository control/status panel is obtained and displayed as a sub-part of the MagmaControlPanel by sending the root object of the current repository #magmaControlPanelOn:  e.g.

magmaSession root magmaControlPanelOn: magmaSession.

If there is not a repository in place then the user is offered the option to create one. It searches for the repository control panels.  These are seaside-components which implement #magmaRootClass and #magmaRootDescription.

[to do]
seasidehosting currently requires the user to manually create the repository directory in the filesystem.
no attempt has been made as yet to ensure that magmaSessions are completely tidied up after using this control panel.
theres is some doubt as to the efficacy of the #done button.


!

!WAMagmaControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 8/14/2006 12:09'!
canBeRoot

^true! !

!WAMagmaControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2006 00:07'!
editorActionsFor: anEntryPoint inEditor: anEditor

| actions isMagmaApplication isLoggingEnabled |

actions := OrderedCollection new.

		
isMagmaApplication := (anEntryPoint isApplication 
	and: [ anEntryPoint configuration ancestors anySatisfy: [ :a | a class = WAMagmaConfiguration ]]).

isLoggingEnabled := isMagmaApplication and: [ (anEntryPoint preferenceAt: #readStrategy) isLogger ].

isMagmaApplication ifTrue: [
	actions add: ((Dictionary new)
				at: #label put: 'magma';
				at: #action put: [ anEditor call: (self new application: anEntryPoint)  ];
				yourself);
			yourself.
].
isLoggingEnabled ifTrue: [ 		
		actions add: ((Dictionary new)
				at: #label put: 'view-log';
				at: #action put: [ anEditor call: (WAMagmaLog log forApplication: anEntryPoint)  ];
				yourself);
				yourself.
		actions add: ((Dictionary new)
				at: #label put: 'clear-log';
				at: #action put: [ anEditor call: (WAMagmaLog log forApplication: anEntryPoint) clear  ];
				yourself);
				yourself.

].
	
^ actions


! !

!WAMagmaControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 9/18/2006 00:49'!
initialize
	self registerAsDispatcherEditorPlugin.
	"self registerAsApplication: 'magma'."! !

!WAMagmaControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 9/18/2006 00:49'!
registerAsDispatcherEditorPlugin

 ^ WADispatcherEditor addPlugin: self! !

!WAMagmaControlPanel methodsFor: 'accessing' stamp: 'kph 9/18/2006 01:26'!
application

^ application! !

!WAMagmaControlPanel methodsFor: 'accessing' stamp: 'kph 9/18/2006 01:26'!
application: app

application := app! !

!WAMagmaControlPanel methodsFor: 'all stats' stamp: 'kph 9/18/2006 04:18'!
cachedObjectsByClassForSession: aSession

^String streamContents: [ :stream |
	stream nextPutAll: 'cachedObjectCountByClass: '.
	aSession cachedObjectCountByClass 
		do: [ :assoc |
			stream nextPutAll: assoc printString.
			stream nextPutAll: ' '; cr.
		]
]! !

!WAMagmaControlPanel methodsFor: 'seaside framework' stamp: 'kph 8/14/2006 23:21'!
children

^ Array with: repositoryControlPanel! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 9/18/2006 06:11'!
createRepository: repositoryClass
	self psuedoAppSession expire.
	psuedoAppSession := nil.
	repositoryControlPanel := nil.
 MagmaRepositoryController create: self location path root: repositoryClass new.
! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 9/18/2006 06:11'!
deleteRepository

| message1 message2 |

message1 := 'Are you sure that you want to delete repository: ', self location path.
message2 := 'Go ahead and delete repository: ',  self location path.

((self confirm: message1) and: [ self confirm: message2 ]) 
	ifTrue: [ 
		self psuedoAppSession expire.
		psuedoAppSession := nil.
		repositoryControlPanel := nil.
		(MagmaRepositoryController controllerOpenedOn: self location path) ifNotNilDo: [ :mc |  mc close ].
		MagmaRepositoryController delete: self location path.	
		
	].! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 9/4/2006 03:15'!
doIt: aString

doneIt := ( Compiler new evaluate: aString in: nil to: nil ) printString.
! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 9/18/2006 02:58'!
done

self psuedoAppSession expire.

self answer! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 9/18/2006 04:24'!
explore: aMagmaSession
 
 [ { aMagmaSession. aMagmaSession root } explore ] fork! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/23/2006 07:02'!
explore: sessionId inController: mrc

	self explore:(self findMagmaSessionWithId: sessionId inController: mrc)! !

!WAMagmaControlPanel methodsFor: 'finalization' stamp: 'kph 9/18/2006 03:51'!
finalize

psuedoAppSession ifNotNil: [

	psuedoAppSession expire.

]
! !

!WAMagmaControlPanel methodsFor: 'all stats' stamp: 'kph 9/20/2006 15:05'!
findMagmaSessionWithId: id inController: mrc

^MagmaSession allInstances detect: [ :ms | (ms id = id) and: [ ms link localRequestServer processor = mrc ] ] ifNone: [ nil ]! !

!WAMagmaControlPanel methodsFor: 'testing' stamp: 'kph 9/5/2006 23:43'!
hasScriptaculous
	Smalltalk at: #SULibrary ifPresent: [ :class |
		^ self session application libraries
			includes: class ].
	^ false! !

!WAMagmaControlPanel methodsFor: 'initialization' stamp: 'kph 9/18/2006 03:49'!
initialize

super initialize.

self finalizationRegistry add: self.! !

!WAMagmaControlPanel methodsFor: 'accessing' stamp: 'kph 9/18/2006 01:27'!
location

^ self application preferenceAt: #location! !

!WAMagmaControlPanel methodsFor: 'accessing' stamp: 'kph 9/18/2006 02:59'!
magmaSession

^self psuedoAppSession magmaSession
! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/18/2006 03:29'!
magmaSession: aBlock ifAbsent: notThereBlock

aBlock
	on: MagmaEnvironmentError 
	do: notThereBlock.  ! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 8/24/2006 02:38'!
presentCreateRepositoryOptionsOn: html

	html heading level: 3; with: [ html text:  'options:'].
		html text: 'You may create a repository with one of the following root objects for this application.'.
		html div class: 'repositories'; with: [ 
			html table: [
				((SystemNavigation default allImplementorsOf: #magmaRootClass) collect: [ :m | m actualClass soleInstance ])				
				do: [ :c | 
						html tableRow: [ 
					 			html tableData: [ html bold:  c magmaRootClass name ].
								html tableData: [ html text:   c magmaRootDescription ].
								html tableData: [ html submitButton callback: [ self createRepository: c magmaRootClass ]; text: 'Create'. ]
						] 
					]
				]
			].! !

!WAMagmaControlPanel methodsFor: 'accessing' stamp: 'kph 9/18/2006 03:00'!
psuedoAppSession

^psuedoAppSession ifNil: [ 
	psuedoAppSession := (application preferenceAt: #sessionClass) application: self application ]! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/20/2006 15:23'!
renderApplicationStatusOn: html

	self magmaSession.
 	self renderLocationOn: html.
	self location isLocal ifTrue: [  html text: '   '. 
		html small: [ 
			html anchor 
				callback: [ self deleteRepository ]; 
				title: 'delete the repository from disk';
				text: '(delete)'. 
		]
	].

	html break.

	html bold: 'Persisted Objects Count: '.
	html text: self magmaSession repositoryController objectCount.

	html break.

	html bold: 'Session Id: '.
	html text: self magmaSession id.

	html break.

	html bold: 'Cached Object Count: '.
	html text: self magmaSession cachedObjectCount.

	html break.

	html bold: 'ReadStrategy: '.
	html text: self magmaSession readStrategy asString.

	(self magmaSession readStrategy isLogged) ifTrue: [
			html anchor callback: [ self call: (WAMagmaLog log forApplication: application)  ]; text: '(log)'.
		].

	html break.

	html bold: 'Root Object: '.
	html text: self magmaSession root asString.
	
	html text: ' '.
	html small: [ 
		html anchor callback: [ self explore: self magmaSession ]; 
			title: 'open explorer in squeak';
			text: '(explore)'.
			.
	].
! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/22/2006 00:54'!
renderContentOn: html

	html heading: 'Application: ', application name.

html form: [

	self magmaSession: [ self renderApplicationStatusOn: html.
			html horizontalRule.
			html render: self repositoryControlPanel.
			html horizontalRule. 
		] 
		ifAbsent: [ :ex | self renderMagmaError: ex on: html ].

	html break.
	html submitButton on: #done of: self.

	html horizontalRule.

	html heading: 'Overall Magma Status'.
	 
	self renderMagmaPreferencesOn: html.
	self renderStatsForAllRepositoriesOn: html.
	
	self renderUtilsOn: html.

].! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/4/2006 02:01'!
renderEvaluatorOn: html
	self
		renderLabel: 'Text-Input'
		control: [ :fid :mid |
			html textInput
				value: textInput;
				callback: [ :value | textInput := value ].
			html space.
			html submitButton
				onClick: (html updater
					id: mid;
					triggerForm: fid;
					callback: [ :r | r render: textInput ];
					return: false);
				text: 'Submit' ]
		model: textInput
		on: html! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 8/10/2006 16:38'!
rendererClass
        ^ WARenderCanvas ! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/4/2006 02:13'!
renderLabel: aString control: aBlock model: anObject on: html
	| fid mid |
	fid := mid := nil.
	html div class: 'row'; with: [
		html div class: 'label'; with: aString.
		html div class: 'control'; with: [
			html form
				id: (fid := html nextId);
				with: [ aBlock value: fid value: (mid := html nextId) ] ].
		html div class: 'model'; id: mid; with: anObject.
		html div class: 'clear' ]! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/18/2006 01:50'!
renderLocationOn: html

	self location isLocal 
		ifTrue: [
			html bold: 'Repository path setting: '.
			html text: self location path.
 		]
		ifFalse: [ 
			html bold: 'Repository remote host: '.
			html text: self location host , ':' , self location port
		].
		
! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/18/2006 01:48'!
renderMagmaError: ex on: html

	self renderLocationOn: html.
	html break.
	html bold: 'Error: ', ex messageText.
	html break.
	self location isLocal 
		ifTrue: [ self renderPresentCreateRepositoryOptionsOn: html	] 
		ifFalse: [ html text: 'Remote repository not available' ].! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/22/2006 01:40'!
renderMagmaPreferencesOn: html

html bold: 'debug proxies '.
html checkbox tooltip: 'print shows proxy'; on: #debugProxies of: MagmaPreferences.
html bold: 'hand status '.
html checkbox tooltip: 'show wait cursor when submitting magma requests'; on: #handStatus of: MagmaPreferences.
html bold: 'debug '.
html checkbox tooltip: 'onError Halt, and 2 day server link timeout'; on: #debug of: MagmaPreferences.! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/2/2006 01:36'!
renderPresentCreateRepositoryOptionsOn: html

	html heading level: 3; with: [ html text:  'options:'].
		html text: 'You may create a repository with one of the following root objects for this application.'.
		html div class: 'repositories'; with: [ 
			html table: [
				((SystemNavigation default allImplementorsOf: #magmaRootClass) collect: [ :m | m actualClass soleInstance ])				
				do: [ :c | 
						html tableRow: [ 
					 			html tableData: [ html bold:  c magmaRootClass name ].
								html tableData: [ html text:   c magmaRootDescription ].
								html tableData: [ html submitButton callback: [ self createRepository: c magmaRootClass ]; text: 'Create'. ]
						] 
					]
				]
			].! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/4/2006 03:16'!
renderServerDoItOn: html
	self
		renderLabel: 'Server Do It'
		control: [ :fid :mid |
			html textInput
				value: textInput;
				callback: [ :value | self doIt: (textInput := value).  ].
			html space.
			html submitButton
				onClick: (html updater
					id: mid;
					triggerForm: fid;
					callback: [ :r | r render:textInput ];
					return: false);
				text: 'do it' ]
		model: doneIt 
		on: html! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/23/2006 06:59'!
renderStatsForAllRepositoriesOn: html

| mSession sessionId |

html orderedList: [ 
	MagmaRepositoryController openControllers do: [ :mrc |
		
		html listItem: [
			html bold: mrc objectCount.
			html text: ' objects in repository: '.
			 
			html bold: mrc directory pathName.
			html orderedList: [
				mrc repository sessions do: [ :client |
					
					mSession := self findMagmaSessionWithId: client sessionId inController: mrc.

					html listItem: [
						mSession ifNil: [ html text: 'session not found' ]
							ifNotNil: [ 
								html bold: 'session id: '.
								html text: client sessionId printString.
								html bold: ' cached objects: '.
								html anchor callback: [ self showCachedObjectsByClassFor: client sessionId inController: mrc ]; 
								text: mSession cachedObjectCount.
							html text: ' '.
							html small: [ html anchor callback: [ self explore: client sessionId inController: mrc ]; text: '(explore)' ].
						]
					].
				]	 
			].			
				"html tableData: [ html text: c numberOfConnectedClients asString ]."
		].
	].
]
	 
 
 


 ! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/22/2006 05:34'!
renderUtilsOn: html

html horizontalRule.

html bold: 'Miscellaneous Utilities: '.

html break.

html submitButton callback: [ MagmaSession cleanUp.
							  repositoryControlPanel := nil ]; text: 'MagmaSession cleanUp'.

html break.

html submitButton callback: [ WAMagmaSharedSession initialize. ]; tooltip: 'New Sessions (Reloads ReadStrategies)';  text: 'Reset WAMagmaSharedSession'.

html break.


html submitButton callback: [ self saveImageSnapshot ]; text: 'Save Server Image'.

self hasScriptaculous ifTrue: [ html horizontalRule.  self renderServerDoItOn: html ].! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/18/2006 04:41'!
repositoryControlPanel

| root |

repositoryControlPanel ifNil: [
	root := self magmaSession root.
	(root respondsTo: #magmaControlPanelOn: ) 
		ifTrue: [ repositoryControlPanel := root magmaControlPanelOn: self magmaSession ]
].

^repositoryControlPanel! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 9/4/2006 01:43'!
saveImageSnapshot

 SmalltalkImage current snapshot: true andQuit: false.! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/23/2006 07:00'!
showCachedObjectsByClassFor:  sessionId inController: mrc 

self inform: (self cachedObjectsByClassForSession: (self findMagmaSessionWithId: sessionId inController: mrc))! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 8/11/2006 14:16'!
style

^ 

'
div.repositories table td {
	border: 1px solid #888;

'! !

WAComponent subclass: #WAMagmaLog
	instanceVariableNames: 'entries printBlocks maxEntries serializer classIdManager firstTime readStrategy showReadStrategy readCount'
	classVariableNames: 'Log'
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaLog class methodsFor: 'nil' stamp: 'kph 9/20/2006 16:08'!
log

Log ifNil: [ Log := self new ].
^Log! !

!WAMagmaLog class methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 05:16'!
reset

Log := nil.! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 00:41'!
classIdManager

^classIdManager! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 01:53'!
clear

entries := OrderedCollection new: maxEntries.
readCount := 0.
! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 05:57'!
entries

^entries! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 01:17'!
entry: type context: aContext 

entries size < maxEntries ifTrue: [ (entries add: aContext copy) receiver: ((type, ':i:on:') asSymbol) ].! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 22:18'!
forApplication: anEntryPoint

	| session |

	  
	session := ((anEntryPoint preferenceAt: #sessionClass) application: anEntryPoint) obtainMagmaSession.

	readStrategy := session readStrategy.
	serializer := session serializer.
	classIdManager := serializer classIdManager.

 ! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 23:49'!
formatterClass

^WAMagmaLogEntryFormatter! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 23:17'!
initialize

maxEntries := 200.
self clear.
readStrategy := nil.! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 22:43'!
keyString

^ 'n: [ms] (current/min/newMin) class-attribute = value'! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 05:18'!
maxEntries

^maxEntries! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 05:18'!
maxEntries: n

maxEntries := n! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 23:22'!
printIndex: i entry: context on: html
"
context expected for
entryForReading: oid at: currentDepth to: minDepth attribute: varIndex ofClassId: classId version: classVersion 
"

| theClass theAttributeName theValue out |

firstTime ifNil: [ firstTime := context tempAt: 8 ].

context isString ifTrue: [  html text: (i asString, ': ', context). html break. ^self ].

classIdManager ifNil: [ ^html bold: '<<no class id manager available>>' ].

theClass := classIdManager classForId: (context tempAt: 5) ifAbsent: [ ^self error: 'could not find class id' ].
theAttributeName := theClass allInstVarNames at: (context tempAt: 4) ifAbsent: [  (context tempAt: 4) asString ].
theValue := serializer objectWithOid: (context tempAt: 1).

out :=  (String streamContents: [ :stream | 

stream 	nextPutAll: i asString;
		nextPutAll: ': [';
		nextPutAll: ((context tempAt: 8) - firstTime) asString;
		nextPutAll: '] (';
		nextPutAll: (context tempAt: 2) asString;
		nextPut: $/;
		nextPutAll: (context tempAt: 3) asString.

(context tempAt: 7) ~= false ifTrue: [
stream		nextPut: $/;
		nextPutAll: (context tempAt: 7) asString ].
stream		nextPutAll: ') ';
		nextPutAll: theClass name;
		nextPut: $-;
		nextPutAll: theAttributeName;
		nextPutAll: ' = ';
		nextPutAll: (theValue printStringLimitedTo: 40);
		yourself.	
]).

(context tempAt: 7) = false ifTrue: [ html text: out ] ifFalse: [ html bold: out ].
html break.

! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 06:14'!
readBegin: context i: entryIndex on: html
 
| theValue |

firstTime ifNil: [ firstTime := context at: 2 ].

readCount := readCount + 1.

html horizontalRule.
theValue := serializer objectWithOid: (context at: 1 ).

html bold: entryIndex asString, (' [', ((context at: 2) - firstTime) asString, '] Read(', readCount asString, ') '); text: (theValue printStringLimitedTo: 70) ; break.

(readCount = 1) ifTrue: [ firstTime := nil ].

 ! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 22:37'!
refresh! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 01:16'!
renderContentOn: html

|   |

html form: [
	html bold: 'Magma Log '.
	html text: 'entries: '.
	html textInput on: #maxEntries of: self.
	html submitButton on: #clear of: self.
	html submitButton on: #refresh of: self.
	html text: ' show read strategy'.
	html checkbox  on: #showReadStrategy of: self.
	html horizontalRule.
	showReadStrategy ifTrue: [ self renderReadStrategyOn: html. 
					html horizontalRule.
 				].
].

html text: self keyString; horizontalRule.

firstTime := nil.
 
self entries withIndexDo:  [ :context :entryIndex |  self perform: context receiver with: context with: entryIndex with: html ].

html break.

! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 15:09'!
rendererClass

^WARenderCanvas
! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 23:02'!
renderReadStrategyOn: html

readStrategy ifNil: [ ^self ].

html bold: 'Read strategy: '.
readStrategy renderOn: html! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 02:30'!
seaside: context i: entryIndex on: html

firstTime ifNil: [ firstTime := context at: 2 ].

html bold: (entryIndex asString, ': [', ((context at: 2) - firstTime) asString, '] ', (context at: 1)).

html break.! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 00:41'!
serializer

^serializer! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 22:22'!
showReadStrategy

^showReadStrategy! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 22:22'!
showReadStrategy: bool

showReadStrategy := bool! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 02:26'!
testRead: context i: entryIndex on: html

"
context expected for
entryForReading: oid at: currentDepth to: minDepth attribute: varIndex ofClassId: classId version: classVersion 
"
 

| theClass theAttributeName theValue out |

firstTime ifNil: [ firstTime := context tempAt: 8 ].

classIdManager ifNil: [ ^html bold: '<<no class id manager available>>' ].

theClass := classIdManager classForId: (context tempAt: 5) ifAbsent: [ ^self error: 'could not find class id' ].
theAttributeName := theClass allInstVarNames at: (context tempAt: 4) ifAbsent: [  (context tempAt: 4) asString ].
theValue := serializer objectWithOid: (context tempAt: 1).

out :=  (String streamContents: [ :stream | 

stream 	nextPutAll: entryIndex asString;
		nextPutAll: ': [';
		nextPutAll: ((context tempAt: 8) - firstTime) asString;
		nextPutAll: '] (';
		nextPutAll: (context tempAt: 2) asString;
		nextPut: $/;
		nextPutAll: (context tempAt: 3) asString.

(context tempAt: 7) ~= false ifTrue: [
stream		nextPut: $/;
		nextPutAll: (context tempAt: 7) asString ].
stream		nextPutAll: ') ';
		nextPutAll: theClass name;
		nextPut: $-;
		nextPutAll: theAttributeName;
		nextPutAll: ' = ';
		nextPutAll: (theValue printStringLimitedTo: 40);
		yourself.	
]).

(context tempAt: 7) = false ifTrue: [ html text: out ] ifFalse: [ html bold: out ].
html break
 

! !

WASystemConfiguration subclass: #WAMagmaConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'mmb 12/5/2005 09:17'!
ancestors

	^ Array with: (WARenderLoopConfiguration new)! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/17/2006 16:20'!
attributes
    "Return the attributes specific to this configuration"

	^ Array with: (WAMagmaLocationAttribute key: #location group: #magma)
			 with: ((WAListAttribute key: #readStrategy group: #magma)
						options: self readStrategyClasses; yourself ).
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 11:44'!
location

	^ MagmaLocalLocation default
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 14:10'!
readStrategy 

^ WAMagmaReadStrategyDefault 
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 14:12'!
readStrategyClasses 

^ WAMagmaReadStrategyDefault withAllSubclasses 
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 11:35'!
repositoryPath

	^ 'store'
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 11:24'!
sessionClass

	^ WAMagmaSession! !

!WAConfigurationEditor methodsFor: '*magma seaside' stamp: 'kph 9/18/2006 01:31'!
renderMagmaLocationAttribute: anAttribute on: html

	| location |
	location := configuration valueForAttribute: anAttribute.

	html div id: 'location'; with: [
		html table: [
			location isLocal
				ifTrue: [
					html tableRow: [  
						html tableData id: 'label'; with: 'path:'.
						html tableData: [ html textInput on: #path of: location ]
					]
				] ifFalse: [
					html tableRow: [  
						html tableData id: 'label'; with: 'host'.
						html tableData: [ html textInput on: #host of: location ]
					].
					html tableRow: [  
						html tableData id: 'label'; with: 'port'.
						html tableData: [ html textInput value: location port;
								callback: [:v | location port: v asNumber] ]
					].
				]
		]
	].
! !

!WAConfigurationEditor methodsFor: '*magma seaside' stamp: 'kph 6/15/2006 20:33'!
visitMagmaLocationAttribute: anAttribute with: html

	| location |
	location := configuration valueForAttribute: anAttribute. 

	html select 
		list: anAttribute options;
		selected: location class;
		beSubmitOnChange;
		labels: [ :ea | ea name ];
		callback: [ :item | 	(configuration valueAt: #location) class == item
			ifFalse: [ configuration takeValue: item default forAttribute: anAttribute. ]
 		];
		yourself.

	self renderMagmaLocationAttribute: anAttribute on: html.! !

WASession subclass: #WAMagmaSession
	instanceVariableNames: 'magmaSession'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaSession commentStamp: 'kph 9/17/2006 17:35' prior: 0!
The Session readStrategy is updated/rebuilt whenever there is a new seaside session, even when the MagmaSession and the repository is shared among sever seaside sessions.!

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/9/2006 17:41'!
commit: aBlock

	self magmaSession commit: aBlock
! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:58'!
expire

	super expire.
	magmaSession ifNotNil: [ magmaSession disconnect. magmaSession := nil ]! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/9/2006 03:15'!
location 

^self application preferenceAt: #location.
! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 06:11'!
log: message

	|timeStamp |					
		
	timeStamp := Time millisecondClockValue. 

^self readStrategyClass isLogger ifTrue: [ WAMagmaLog log entry: 'seaside' context: thisContext ]
 ! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/17/2006 17:16'!
magmaSession

^ magmaSession ifNil: [ 	magmaSession := self obtainMagmaSession ]! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 02:23'!
obtainMagmaSession

self log: 'Obtaining MagmaSession'.

^self readStrategyClass setStrategyFor: (self location newSessionAs: 'seaside').! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/17/2006 16:56'!
readStrategyClass

 ^ self application preferenceAt: #readStrategy! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2006 03:41'!
repositoryPath
	"This is a convenience method to get the repository directory path from Seaside"

	^ self application preferenceAt: #repositoryPath! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:52'!
root

	^ self magmaSession root
! !

WAMagmaSession subclass: #WAMagmaSharedSession
	instanceVariableNames: ''
	classVariableNames: 'MagmaSessions'
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaSharedSession commentStamp: 'kph 9/17/2006 02:42' prior: 0!
WAMagmaSharedSession keeps one session per repository, and this is provided to each Seaside Session. i.e. each seaside session can access the database but needs to be aware that it may be sharing its view of the model with other seaside sessions.

Pier has a model locking mechanism in place to prevent concurrent edits, and so will perform better with WAMagmaSharedSession than with a standard WAMagmaSession Since sharing the magma session avoids the overhead of connecting to the database at the beginning of every user session.

Rules for use:
Do not abort, you may ruin someone else's transaction.
Ensure that commits are negotiated amongst the sharing users via locking. If one seaside session commits: while another is in mid transaction their changes will be lost. 
To use a shared session there should be one data model that manages commits: and aborts on behalf of all of its seaside session clients.
!

!WAMagmaSharedSession class methodsFor: 'class initialization' stamp: 'kph 9/9/2006 03:32'!
initialize

MagmaSessions := Dictionary new.! !

!WAMagmaSharedSession class methodsFor: 'class initialization' stamp: 'kph 9/19/2006 13:20'!
magmaSessions

^MagmaSessions

"self magmaSessions"! !

!WAMagmaSharedSession methodsFor: 'as yet unclassified' stamp: 'kph 9/17/2006 17:13'!
expire

	super expire.
	magmaSession ifNotNil: [ magmaSession := nil ]! !

!WAMagmaSharedSession methodsFor: 'as yet unclassified' stamp: 'kph 9/17/2006 17:14'!
magmaAbortOnRequest.

"dont for a shared session"! !

!WAMagmaSharedSession methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2006 16:39'!
obtainMagmaSession

| ms |

ms := MagmaSessions at: (self location) ifAbsent: [ nil ].

((ms isNil or: [ ms isOpen not ]) or: [ ms isConnected not]) 
	ifTrue: [ ms := MagmaSessions at: self location put: super obtainMagmaSession ].

^ms! !

!MagmaLocation methodsFor: '*magma seaside' stamp: 'kph 9/9/2006 03:21'!
newSessionAs: userName

 ^ self newSession connectAs: userName; yourself! !

MaReadStrategy subclass: #WAMagmaReadStrategyDefault
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaReadStrategyDefault commentStamp: 'kph 9/19/2006 17:53' prior: 0!
This class is a subclass of MaReadStrategy enabling specialisation of read strategy behaviour.

Class methods build and set a specific read strategy for a magmaSession.

The default building behaviour is for the root object of the repository to be read and be asked to contribute to the ReadStrategy which is an instance of this class. In this way applications that have their own bespoke root class can control the read strategy by implementing #buildStrategyOn:

Alternative admin-user selectable (via seaside/config) read strategies may be supplied by providing subclasses to this class. These may override the default building behaviour if desired. They may also over-ride MaReadStrategy behaivour.

In seaside the Session readStrategy is updated/rebuilt whenever there is a new seaside session, even when the MagmaSession and the repository is shared among sever seaside sessions.
!

!WAMagmaReadStrategyDefault class methodsFor: 'as yet unclassified' stamp: 'kph 9/18/2006 03:20'!
askRoot: root toBuildReadStrategyOn: theStrategy


	(root respondsTo: #buildReadStrategyOn:) 
		ifTrue: [ root buildReadStrategyOn: theStrategy ].

! !

!WAMagmaReadStrategyDefault class methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 05:56'!
isLogger

^false! !

!WAMagmaReadStrategyDefault class methodsFor: 'as yet unclassified' stamp: 'kph 9/19/2006 17:47'!
setStrategyFor: session

| theStrategy |

theStrategy := self new.

self thisStrategyOn: theStrategy.
self askRoot: session root toBuildReadStrategyOn: theStrategy.

session readStrategy: theStrategy.

^session! !

!WAMagmaReadStrategyDefault class methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 02:16'!
thisStrategyOn: strategy

"subclasses may specialise this method"! !

!WAMagmaReadStrategyDefault methodsFor: 'nil' stamp: 'kph 9/19/2006 17:56'!
forVariableNamed: aString onAny: aClass readToDepth: anInteger

| specs |

	(aClass allInstVarNames includes: aString)
		ifFalse:
			[ MagmaUserError signal: aString , ' is not an attribute of ' , aClass name ].
	
specs := depthSpecifications at: aClass ifAbsent: [ self onAny: aClass readToDepth: 0 ].

specs value ifNil: [ specs value: (self depthDictionaryOfSize: aClass instSize) ].
			
specs value at: aString
			put: anInteger! !

!WAMagmaReadStrategyDefault methodsFor: 'as yet unclassified' stamp: 'kph 9/19/2006 17:56'!
instVarMapFor: aMaClassDefinition
	"Answer an Array with an instVarMap of aMaClassDefinition according to user-declared read depths."

	| specifiedDepths answer |
	(aMaClassDefinition isDefined
	and: [ depthSpecifications includesKey: aMaClassDefinition classObject ])
		ifTrue:
			[ specifiedDepths _ depthSpecifications at: aMaClassDefinition classObject.
			specifiedDepths value
				ifNil: [ answer _ specifiedDepths key ]
				ifNotNil:
					[ answer _ self depthArrayOfSize: aMaClassDefinition namedInstSize default: specifiedDepths key.
					specifiedDepths value keysAndValuesDo:
						[ : eachInstVarName : eachDepth |
						answer
							at: (aMaClassDefinition allInstVarNames indexOf: eachInstVarName)
							put: eachDepth ] ] ].
	^ answer! !

!WAMagmaReadStrategyDefault methodsFor: 'nil' stamp: 'kph 9/20/2006 15:24'!
isLogged

^self class isLogger! !

!WAMagmaReadStrategyDefault methodsFor: 'as yet unclassified' stamp: 'kph 9/19/2006 17:56'!
onAny: aClass readToDepth: anInteger

	^depthSpecifications at: aClass ifAbsentPut: [ Association key: anInteger value: nil ].
! !

!WAMagmaReadStrategyDefault methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 23:01'!
renderOn: html

html text: ' minimumDepth: '; text: self minimumDepth; break.

depthSpecifications keysAndValuesDo: [ :k :v |  html bold: k; text: ' : '; text: v; break ].! !

WAMagmaReadStrategyDefault subclass: #WAMagmaReadStrategyWithLogging
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaReadStrategyWithLogging class methodsFor: 'nil' stamp: 'kph 9/20/2006 05:56'!
isLogger

^true! !

!WAMagmaReadStrategyWithLogging methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 14:46'!
log

^self logClass log! !

!WAMagmaReadStrategyWithLogging methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 14:41'!
logClass

^WAMagmaLog ! !

!WAMagmaReadStrategyWithLogging methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2006 05:28'!
signalBeginningToRead: oidInteger

	|timeStamp |					

	timeStamp := Time millisecondClockValue.
	self log entry: #readBegin context: thisContext! !

!WAMagmaReadStrategyWithLogging methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2006 05:24'!
testRead: oid 
    wantedAt: currentDepth
		   to: minDepth
 forAttribute: varIndex
ofClassWithId: classId
	  version: classVersion

"we log (lazily) by sending this method's context to the log, changing this method's args and 
 temporary variables may effect the Log's output"

| newMinDepth timeStamp |					
		
timeStamp := Time millisecondClockValue.
newMinDepth :=  super testRead: oid wantedAt: currentDepth
						to: minDepth
						forAttribute: varIndex
						ofClassWithId: classId
						version: classVersion.

self log entry: #testRead context: thisContext. 	

^newMinDepth! !

!MagmaRepositoryController class methodsFor: '*magma seaside' stamp: 'kph 9/1/2006 02:08'!
controllerOpenedOn: pathName

| path | 

path := (self fd: pathName) pathName.

	^ OpenControllers
		maDetect: [ : each | each directory pathName = path ]
		ifFound: [ : foundController | foundController ensureOpen ]
		ifNone: [ nil ]! !

!MagmaRepositoryController class methodsFor: '*magma seaside' stamp: 'kph 9/1/2006 01:53'!
create: localNameOrFullyQualifiedPathString

	"Creates a repository with an initial root of nil.  I #assureExistence of the localNameOrFullyQualifiedPathString."

	| fd |

	fd := self fd: localNameOrFullyQualifiedPathString. 
	self validateCanCreateIn: fd.
	self new createRepositoryAt: fd! !

!MagmaRepositoryController class methodsFor: '*magma seaside' stamp: 'kph 9/1/2006 01:57'!
delete: localNameOrFullyQualifiedPathString
	"Delete the just the files in fullyQualifiedPathString that are part of the Magma repository that resides there."
	| fd |

	fd := self fd: localNameOrFullyQualifiedPathString.

	(fd exists and: [ fd fileExists: MaObjectFiler objectsFilename ]) ifFalse:
		[ (MagmaNotification new messageText: fd pathName , ' does not exist, nothing to delete.') signal.
		^ self ].
	(self filesFor: fd pathName), { (MaRecoveryManager commitPackagesFilename) } do:
		[ : each |
			fd deleteFileNamed: each asString
			ifAbsent: [ MagmaNotification signal: 'Couldn''t find ' , each asString ] ]! !

!MagmaRepositoryController class methodsFor: '*magma seaside' stamp: 'kph 9/1/2006 01:52'!
fd: path

^FileDirectory on: (FileDirectory default fullNameFor: path).

	 ! !

!MagmaRepositoryController class methodsFor: '*magma seaside' stamp: 'kph 8/24/2006 22:21'!
openControllers

^OpenControllers! !

!MagmaRepositoryController class methodsFor: '*magma seaside' stamp: 'kph 9/1/2006 02:08'!
openedOn: pathString

	| existingController  |
	^ (existingController := self controllerOpenedOn:  pathString)
		ifNil: [ self open: pathString ]
		ifNotNil: [ existingController ].! !

!MagmaRepositoryController class methodsFor: '*magma seaside' stamp: 'kph 9/1/2006 01:56'!
open:pathString

	^ self new open: (self fd: pathString)! !

!UnixFileDirectory methodsFor: '*magma seaside' stamp: 'kph 9/1/2006 01:38'!
directoryExists: filenameOrPath
    "Handles the special case of testing for the root dir: there isn't a
    possibility to express the root dir as full pathname like '/foo'."

    ^ filenameOrPath = '/'
        or: [ filenameOrPath = self class default pathName
        or: [ super directoryExists: filenameOrPath ] ]
! !

!MaBasicReadStrategy methodsFor: '*magma seaside' stamp: 'kph 9/20/2006 23:39'!
signalBeginningToRead: oidInteger! !

!MaBasicReadStrategy methodsFor: '*magma seaside' stamp: 'kph 9/20/2006 13:41'!
testRead: oid wantedAt: currentDepth
			to: minDepth
			forAttribute: varIndex
			ofClassWithId: classId
			version: classVersion

| newMinDepth |

	currentDepth < (
						newMinDepth _
							(self 
								depthOfAttribute: varIndex
								onClassWithId: classId
								version: classVersion) + currentDepth
									max: minDepth)

	ifFalse: [ newMinDepth := false ].

^newMinDepth
! !

!MagmaMutatingProxy methodsFor: '*magma seaside' stamp: 'kph 9/22/2006 02:00'!
asExplorerString
	^ self printString! !

!MagmaMutatingProxy methodsFor: '*magma seaside' stamp: 'kph 9/22/2006 02:10'!
printOn: aStream

	MagmaPreferences debugProxies  
		ifTrue:
			[ super printOn: aStream.
					aStream nextPutAll: ('(',oid asString, '/',session id asString,')') ]
		ifFalse:
			[ self mutant printOn: aStream ]
! !
WAMagmaControlPanel initialize!
WAMagmaSharedSession initialize!
